+   [TensorFlow 1.x 深度学习秘籍](docs/tf-1x-dl-cookbook/README.md)
    +   [零、前言](docs/tf-1x-dl-cookbook/00.md)
    +   [一、TensorFlow 简介](docs/tf-1x-dl-cookbook/01.md)
    +   [二、回归](docs/tf-1x-dl-cookbook/02.md)
    +   [三、神经网络：感知器](docs/tf-1x-dl-cookbook/03.md)
    +   [四、卷积神经网络](docs/tf-1x-dl-cookbook/04.md)
    +   [五、高级卷积神经网络](docs/tf-1x-dl-cookbook/05.md)
    +   [六、循环神经网络](docs/tf-1x-dl-cookbook/06.md)
    +   [七、无监督学习](docs/tf-1x-dl-cookbook/07.md)
    +   [八、自编码器](docs/tf-1x-dl-cookbook/08.md)
    +   [九、强化学习](docs/tf-1x-dl-cookbook/09.md)
    +   [十、移动计算](docs/tf-1x-dl-cookbook/10.md)
    +   [十一、生成模型和 CapsNet](docs/tf-1x-dl-cookbook/11.md)
    +   [十二、分布式 TensorFlow 和云深度学习](docs/tf-1x-dl-cookbook/12.md)
    +   [十三、AutoML 和学习如何学习（元学习）](docs/tf-1x-dl-cookbook/13.md)
    +   [十四、TensorFlow 处理单元](docs/tf-1x-dl-cookbook/14.md)
+   [使用 TensorFlow 构建机器学习项目中文版](docs/build-ml-proj-tf-zh/README.md)
    +   [一、探索和转换数据](docs/build-ml-proj-tf-zh/ch01.md)
    +   [二、聚类](docs/build-ml-proj-tf-zh/ch02.md)
    +   [三、线性回归](docs/build-ml-proj-tf-zh/ch03.md)
    +   [四、逻辑回归](docs/build-ml-proj-tf-zh/ch04.md)
    +   [五、简单的前馈神经网络](docs/build-ml-proj-tf-zh/ch05.md)
    +   [六、卷积神经网络](docs/build-ml-proj-tf-zh/ch06.md)
    +   [七、循环神经网络和 LSTM](docs/build-ml-proj-tf-zh/ch07.md)
    +   [八、深度神经网络](docs/build-ml-proj-tf-zh/ch08.md)
    +   [九、大规模运行模型 -- GPU 和服务](docs/build-ml-proj-tf-zh/ch09.md)
    +   [十、库安装和其他提示](docs/build-ml-proj-tf-zh/ch10.md)
+   [TensorFlow 深度学习中文第二版](docs/dl-tf-2e-zh/README.md)
    +   [一、人工神经网络](docs/dl-tf-2e-zh/ch01.md)
    +   [二、TensorFlow v1.6 的新功能是什么？](docs/dl-tf-2e-zh/ch02.md)
    +   [三、实现前馈神经网络](docs/dl-tf-2e-zh/ch03.md)
    +   [四、CNN 实战](docs/dl-tf-2e-zh/ch04.md)
    +   [五、使用 TensorFlow 实现自编码器](docs/dl-tf-2e-zh/ch05.md)
    +   [六、RNN 和梯度消失或爆炸问题](docs/dl-tf-2e-zh/ch06.md)
    +   [七、TensorFlow GPU 配置](docs/dl-tf-2e-zh/ch07.md)
    +   [八、TFLearn](docs/dl-tf-2e-zh/ch08.md)
    +   [九、使用协同过滤的电影推荐](docs/dl-tf-2e-zh/ch09.md)
    +   [十、OpenAI Gym](docs/dl-tf-2e-zh/ch10.md)
+   [TensorFlow 深度学习实战指南中文版](docs/hands-on-dl-tf-zh/README.md)
    +   [一、入门](docs/hands-on-dl-tf-zh/ch01.md)
    +   [二、深度神经网络](docs/hands-on-dl-tf-zh/ch02.md)
    +   [三、卷积神经网络](docs/hands-on-dl-tf-zh/ch03.md)
    +   [四、循环神经网络介绍](docs/hands-on-dl-tf-zh/ch04.md)
    +   [五、总结](docs/hands-on-dl-tf-zh/ch05.md)
+   [精通 TensorFlow 1.x](docs/mastering-tf-1x-zh/README.md)
    +   [一、TensorFlow 101](docs/mastering-tf-1x-zh/ch01.md)
    +   [二、TensorFlow 的高级库](docs/mastering-tf-1x-zh/ch02.md)
    +   [三、Keras 101](docs/mastering-tf-1x-zh/ch03.md)
    +   [四、TensorFlow 中的经典机器学习](docs/mastering-tf-1x-zh/ch04.md)
    +   [五、TensorFlow 和 Keras 中的神经网络和 MLP](docs/mastering-tf-1x-zh/ch05.md)
    +   [六、TensorFlow 和 Keras 中的 RNN](docs/mastering-tf-1x-zh/ch06.md)
    +   [七、TensorFlow 和 Keras 中的用于时间序列数据的 RNN](docs/mastering-tf-1x-zh/ch07.md)
    +   [八、TensorFlow 和 Keras 中的用于文本数据的 RNN](docs/mastering-tf-1x-zh/ch08.md)
    +   [九、TensorFlow 和 Keras 中的 CNN](docs/mastering-tf-1x-zh/ch09.md)
    +   [十、TensorFlow 和 Keras 中的自编码器](docs/mastering-tf-1x-zh/ch10.md)
    +   [十一、TF 服务：生产中的 TensorFlow 模型](docs/mastering-tf-1x-zh/ch11.md)
    +   [十二、迁移学习和预训练模型](docs/mastering-tf-1x-zh/ch12.md)
    +   [十三、深度强化学习](docs/mastering-tf-1x-zh/ch13.md)
    +   [十四、生成对抗网络](docs/mastering-tf-1x-zh/ch14.md)
    +   [十五、TensorFlow 集群的分布式模型](docs/mastering-tf-1x-zh/ch15.md)
    +   [十六、移动和嵌入式平台上的 TensorFlow 模型](docs/mastering-tf-1x-zh/ch16.md)
    +   [十七、R 中的 TensorFlow 和 Keras](docs/mastering-tf-1x-zh/ch17.md)
    +   [十八、调试 TensorFlow 模型](docs/mastering-tf-1x-zh/ch18.md)
    +   [十九、张量处理单元](docs/mastering-tf-1x-zh/ch19.md)
+   [TensorFlow 机器学习秘籍中文第二版](docs/tf-ml-cookbook-2e-zh/README.md)
    +   [一、TensorFlow 入门](docs/tf-ml-cookbook-2e-zh/ch01.md)
    +   [二、TensorFlow 的方式](docs/tf-ml-cookbook-2e-zh/ch02.md)
    +   [三、线性回归](docs/tf-ml-cookbook-2e-zh/ch03.md)
    +   [四、支持向量机](docs/tf-ml-cookbook-2e-zh/ch04.md)
    +   [五、最近邻方法](docs/tf-ml-cookbook-2e-zh/ch05.md)
    +   [六、神经网络](docs/tf-ml-cookbook-2e-zh/ch06.md)
    +   [七、自然语言处理](docs/tf-ml-cookbook-2e-zh/ch07.md)
    +   [八、卷积神经网络](docs/tf-ml-cookbook-2e-zh/ch08.md)
    +   [九、循环神经网络](docs/tf-ml-cookbook-2e-zh/ch09.md)
    +   [十、将 TensorFlow 投入生产](docs/tf-ml-cookbook-2e-zh/ch10.md)
    +   [十一、更多 TensorFlow](docs/tf-ml-cookbook-2e-zh/ch11.md)
+   [与 TensorFlow 的初次接触](docs/first_contact_with_tensorFlow/README.md)
    +   [前言](docs/first_contact_with_tensorFlow/0.md)
    +   [1. TensorFlow 基础知识](docs/first_contact_with_tensorFlow/1.md)
    +   [2. TensorFlow 中的线性回归](docs/first_contact_with_tensorFlow/2.md)
    +   [3. TensorFlow 中的聚类](docs/first_contact_with_tensorFlow/3.md)
    +   [4. TensorFlow 中的单层神经网络](docs/first_contact_with_tensorFlow/4.md)
    +   [5. TensorFlow 中的多层神经网络](docs/first_contact_with_tensorFlow/5.md)
    +   [6. 并行](docs/first_contact_with_tensorFlow/6.md)
    +   [后记](docs/first_contact_with_tensorFlow/7.md)
+   [TensorFlow 学习指南](docs/learning-tf-zh/README.md)
    +   [一、基础](docs/learning-tf-zh/1.md)
    +   [二、线性模型](docs/learning-tf-zh/2.md)
    +   [三、学习](docs/learning-tf-zh/3.md)
    +   [四、分布式](docs/learning-tf-zh/4.md)
+   [TensorFlow Rager 教程](docs/tf-eager-tut/README.md)
    +   [一、如何使用 TensorFlow Eager 构建简单的神经网络](docs/tf-eager-tut/1.md)
    +   [二、在 Eager 模式中使用指标](docs/tf-eager-tut/2.md)
    +   [三、如何保存和恢复训练模型](docs/tf-eager-tut/3.md)
    +   [四、文本序列到 TFRecords](docs/tf-eager-tut/4.md)
    +   [五、如何将原始图片数据转换为 TFRecords](docs/tf-eager-tut/5.md)
    +   [六、如何使用 TensorFlow Eager 从 TFRecords 批量读取数据](docs/tf-eager-tut/6.md)
    +   [七、使用 TensorFlow Eager 构建用于情感识别的卷积神经网络（CNN）](docs/tf-eager-tut/7.md)
    +   [八、用于 TensorFlow Eager 序列分类的动态循坏神经网络](docs/tf-eager-tut/8.md)
    +   [九、用于 TensorFlow Eager 时间序列回归的递归神经网络](docs/tf-eager-tut/9.md)
+   [TensorFlow 高效编程](docs/effective-tf.md)
+   [图嵌入综述：问题，技术与应用](docs/ge-survey-arxiv-1709-07604-zh/README.md)
    +   [一、引言](docs/ge-survey-arxiv-1709-07604-zh/1.md)
    +   [三、图嵌入的问题设定](docs/ge-survey-arxiv-1709-07604-zh/2.md)
    +   [四、图嵌入技术](docs/ge-survey-arxiv-1709-07604-zh/3.md)
    +   [基于边重构的优化问题](docs/ge-survey-arxiv-1709-07604-zh/4.md)
    +   [应用](docs/ge-survey-arxiv-1709-07604-zh/5.md)
+   [基于深度学习的推荐系统：综述和新视角](docs/rs-survey-arxiv-1707-07435-zh/README.md)
    +   [引言](docs/rs-survey-arxiv-1707-07435-zh/1.md)
    +   [基于深度学习的推荐：最先进的技术](docs/rs-survey-arxiv-1707-07435-zh/2.md)
    +   [基于卷积神经网络的推荐](docs/rs-survey-arxiv-1707-07435-zh/3.md)
+   [关于卷积神经网络我们理解了什么](docs/what-do-we-understand-about-convnet/README.md)
    +   [第1章概论](docs/what-do-we-understand-about-convnet/1.md)
    +   [第2章多层网络](docs/what-do-we-understand-about-convnet/2.1.1-2.1.3.md)
    +   [2.1.4生成对抗网络](docs/what-do-we-understand-about-convnet/2.1.4-2.1.6.md)
    +   [2.2.1最近ConvNets演变中的关键架构](docs/what-do-we-understand-about-convnet/2.2.1.md)
    +   [2.2.2走向ConvNet不变性](docs/what-do-we-understand-about-convnet/2.2.2-2.2.3.md)
    +   [2.3时空卷积网络](docs/what-do-we-understand-about-convnet/2.3-2.4.md)
    +   [第3章了解ConvNets构建块](docs/what-do-we-understand-about-convnet/3.1.md)
    +   [3.2整改](docs/what-do-we-understand-about-convnet/3.2.md)
    +   [3.3规范化](docs/what-do-we-understand-about-convnet/3.3.md)
    +   [3.4汇集](docs/what-do-we-understand-about-convnet/3.4-3.5.md)
    +   [第四章现状](docs/what-do-we-understand-about-convnet/4.1.md)
    +   [4.2打开问题](docs/what-do-we-understand-about-convnet/4.2.md)
    +   [参考](docs/what-do-we-understand-about-convnet/ref.md)
+   [机器学习超级复习笔记](docs/super-machine-learning-revision-notes/README.md)
+   [Python 迁移学习实用指南](docs/handson-tl-py/README.md)
    +   [零、前言](docs/handson-tl-py/0.md)
    +   [一、机器学习基础](docs/handson-tl-py/1.md)
    +   [二、深度学习基础](docs/handson-tl-py/2.md)
    +   [三、了解深度学习架构](docs/handson-tl-py/3.md)
    +   [四、迁移学习基础](docs/handson-tl-py/4.md)
    +   [五、释放迁移学习的力量](docs/handson-tl-py/5.md)
    +   [六、图像识别与分类](docs/handson-tl-py/6.md)
    +   [七、文本文件分类](docs/handson-tl-py/7.md)
    +   [八、音频事件识别与分类](docs/handson-tl-py/8.md)
    +   [九、DeepDream](docs/handson-tl-py/9.md)
    +   [十、自动图像字幕生成器](docs/handson-tl-py/10.md)
    +   [十一、图像着色](docs/handson-tl-py/11.md)
+   [面向计算机视觉的深度学习](docs/dl-cv/README.md)
    +   [零、前言](docs/dl-cv/00.md)
    +   [一、入门](docs/dl-cv/01.md)
    +   [二、图像分类](docs/dl-cv/02.md)
    +   [三、图像检索](docs/dl-cv/03.md)
    +   [四、对象检测](docs/dl-cv/04.md)
    +   [五、语义分割](docs/dl-cv/05.md)
    +   [六、相似性学习](docs/dl-cv/06.md)
    +   [七、图像字幕](docs/dl-cv/07.md)
    +   [八、生成模型](docs/dl-cv/08.md)
    +   [九、视频分类](docs/dl-cv/09.md)
    +   [十、部署](docs/dl-cv/10.md)
+   [深度学习快速参考](docs/dl-quick-ref/README.md)
    +   [零、前言](docs/dl-quick-ref/00.md)
    +   [一、深度学习的基础](docs/dl-quick-ref/01.md)
    +   [二、使用深度学习解决回归问题](docs/dl-quick-ref/02.md)
    +   [三、使用 TensorBoard 监控网络训练](docs/dl-quick-ref/03.md)
    +   [四、使用深度学习解决二分类问题](docs/dl-quick-ref/04.md)
    +   [五、使用 Keras 解决多分类问题](docs/dl-quick-ref/05.md)
    +   [六、超参数优化](docs/dl-quick-ref/06.md)
    +   [七、从头开始训练 CNN](docs/dl-quick-ref/07.md)
    +   [八、将预训练的 CNN 用于迁移学习](docs/dl-quick-ref/08.md)
    +   [九、从头开始训练 RNN](docs/dl-quick-ref/09.md)
    +   [十、使用词嵌入从头开始训练 LSTM](docs/dl-quick-ref/10.md)
    +   [十一、训练 Seq2Seq 模型](docs/dl-quick-ref/11.md)
    +   [十二、深度强化学习](docs/dl-quick-ref/12.md)
    +   [十三、生成对抗网络](docs/dl-quick-ref/13.md)
+   [TensorFlow 2.0 快速入门指南](docs/tf-20-quick-start-guide/README.md)
    +   [零、前言](docs/tf-20-quick-start-guide/00.md)
    +   [第 1 部分：TensorFlow 2.00 Alpha 简介](docs/tf-20-quick-start-guide/s1.md)
    +   [一、TensorFlow 2 简介](docs/tf-20-quick-start-guide/01.md)
    +   [二、Keras：TensorFlow 2 的高级 API](docs/tf-20-quick-start-guide/02.md)
    +   [三、TensorFlow 2 和 ANN 技术](docs/tf-20-quick-start-guide/03.md)
    +   [第 2 部分：TensorFlow 2.00 Alpha 中的监督和无监督学习](docs/tf-20-quick-start-guide/s2.md)
    +   [四、TensorFlow 2 和监督机器学习](docs/tf-20-quick-start-guide/04.md)
    +   [五、TensorFlow 2 和无监督学习](docs/tf-20-quick-start-guide/05.md)
    +   [第 3 部分：TensorFlow 2.00 Alpha 的神经网络应用](docs/tf-20-quick-start-guide/s3.md)
    +   [六、使用 TensorFlow 2 识别图像](docs/tf-20-quick-start-guide/06.md)
    +   [七、TensorFlow 2 和神经风格迁移](docs/tf-20-quick-start-guide/07.md)
    +   [八、TensorFlow 2 和循环神经网络](docs/tf-20-quick-start-guide/08.md)
    +   [九、TensorFlow 估计器和 TensorFlow HUB](docs/tf-20-quick-start-guide/09.md)
    +   [十、从 tf1.12 转换为 tf2](docs/tf-20-quick-start-guide/10.md)
+   [TensorFlow 入门](docs/get-start-tf/README.md)
    +   [零、前言](docs/get-start-tf/ch00.md)
    +   [一、TensorFlow 基本概念](docs/get-start-tf/ch01.md)
    +   [二、TensorFlow 数学运算](docs/get-start-tf/ch02.md)
    +   [三、机器学习入门](docs/get-start-tf/ch03.md)
    +   [四、神经网络简介](docs/get-start-tf/ch04.md)
    +   [五、深度学习](docs/get-start-tf/ch05.md)
    +   [六、TensorFlow GPU 编程和服务](docs/get-start-tf/ch06.md)
+   [TensorFlow 卷积神经网络实用指南](docs/handson-cnn-tf/README.md)
    +   [零、前言](docs/handson-cnn-tf/0.md)
    +   [一、TensorFlow 的设置和介绍](docs/handson-cnn-tf/1.md)
    +   [二、深度学习和卷积神经网络](docs/handson-cnn-tf/2.md)
    +   [三、TensorFlow 中的图像分类](docs/handson-cnn-tf/3.md)
    +   [四、目标检测与分割](docs/handson-cnn-tf/4.md)
    +   [五、VGG，Inception，ResNet 和 MobileNets](docs/handson-cnn-tf/5.md)
    +   [六、自编码器，变分自编码器和生成对抗网络](docs/handson-cnn-tf/6.md)
    +   [七、迁移学习](docs/handson-cnn-tf/7.md)
    +   [八、机器学习最佳实践和故障排除](docs/handson-cnn-tf/8.md)
    +   [九、大规模训练](docs/handson-cnn-tf/9.md)
    +   [十、参考文献](docs/handson-cnn-tf/10.md)
+   [Python 人工智能中文版](docs/ai-py/README.md)
    +   [0 前言](docs/ai-py/00.md)
    +   [1 人工智能简介](docs/ai-py/01.md)
    +   [2 人工智能的基本用例](docs/ai-py/02.md)
    +   [3 机器学习管道](docs/ai-py/03.md)
    +   [4 特征选择和特征工程](docs/ai-py/04.md)
    +   [5 使用监督学习的分类和回归](docs/ai-py/05.md)
    +   [6 集成学习的预测分析](docs/ai-py/06.md)
    +   [7 通过无监督学习检测模式](docs/ai-py/07.md)
    +   [8 构建推荐系统](docs/ai-py/08.md)
    +   [9 逻辑编程](docs/ai-py/09.md)
    +   [10 启发式搜索技术](docs/ai-py/10.md)
    +   [11 遗传算法和遗传编程](docs/ai-py/11.md)
    +   [12 云上的人工智能](docs/ai-py/12.md)
    +   [13 使用人工智能构建游戏](docs/ai-py/13.md)
    +   [14 构建语音识别器](docs/ai-py/14.md)
    +   [15 自然语言处理](docs/ai-py/15.md)
    +   [16 聊天机器人](docs/ai-py/16.md)
    +   [17 序列数据和时间序列分析](docs/ai-py/17.md)
    +   [18 图像识别](docs/ai-py/18.md)
    +   [19 神经网络](docs/ai-py/19.md)
    +   [20 将卷积神经网络用于深度学习](docs/ai-py/20.md)
    +   [21 循环神经网络和其他深度学习模型](docs/ai-py/21.md)
    +   [22 通过强化学习创建智能体](docs/ai-py/22.md)
    +   [23 人工智能和大数据](docs/ai-py/23.md)
+   [Python 无监督学习实用指南](docs/handson-unsup-learn-py/README.md)
    +   [零、前言](docs/handson-unsup-learn-py/00.md)
    +   [一、无监督学习入门](docs/handson-unsup-learn-py/01.md)
    +   [二、聚类基础](docs/handson-unsup-learn-py/02.md)
    +   [三、高级聚类](docs/handson-unsup-learn-py/03.md)
    +   [四、实用的层次聚类](docs/handson-unsup-learn-py/04.md)
    +   [五、软聚类和高斯混合模型](docs/handson-unsup-learn-py/05.md)
    +   [六、异常检测](docs/handson-unsup-learn-py/06.md)
    +   [七、降维和成分分析](docs/handson-unsup-learn-py/07.md)
    +   [八、无监督神经网络模型](docs/handson-unsup-learn-py/08.md)
    +   [九、生成对抗网络和 SOM](docs/handson-unsup-learn-py/09.md)
    +   [十、习题](docs/handson-unsup-learn-py/10.md)
+   [生成对抗网络项目](docs/gan-proj/README.md)
    +   [零、前言](docs/gan-proj/0.md)
    +   [一、生成对抗网络简介](docs/gan-proj/1.md)
    +   [二、3D-GAN -- 使用 GAN 生成形状](docs/gan-proj/2.md)
    +   [三、使用条件 GAN 进行人脸老化](docs/gan-proj/3.md)
    +   [四、使用 DCGAN 生成动漫角色](docs/gan-proj/4.md)
    +   [五、使用 SRGAN 生成逼真的图像](docs/gan-proj/5.md)
    +   [六、StackGAN - 逼真的文本到图像合成](docs/gan-proj/6.md)
    +   [七、CycleGAN - 将绘画变成照片](docs/gan-proj/7.md)
    +   [八、条件 GAN - 使用条件对抗网络的图像到图像翻译](docs/gan-proj/8.md)
    +   [九、预测 GAN 的未来](docs/gan-proj/9.md)
+   [TensorFlow 智能移动项目](docs/intel-mobi-proj-tf/README.md)
    +   [零、前言](docs/intel-mobi-proj-tf/00.md)
    +   [一、移动 TensorFlow 入门](docs/intel-mobi-proj-tf/01.md)
    +   [二、通过迁移学习对图像进行分类](docs/intel-mobi-proj-tf/02.md)
    +   [三、检测物体及其位置](docs/intel-mobi-proj-tf/03.md)
    +   [四、以惊人的艺术风格变换图片](docs/intel-mobi-proj-tf/04.md)
    +   [五、了解简单的语音命令](docs/intel-mobi-proj-tf/05.md)
    +   [六、用自然语言描述图像](docs/intel-mobi-proj-tf/06.md)
    +   [七、使用 CNN 和 LSTM 识别绘画](docs/intel-mobi-proj-tf/07.md)
    +   [八、用 RNN 预测股价](docs/intel-mobi-proj-tf/08.md)
    +   [九、使用 GAN 生成和增强图像](docs/intel-mobi-proj-tf/09.md)
    +   [十、构建类似 AlphaZero 的手机游戏应用](docs/intel-mobi-proj-tf/10.md)
    +   [十一、在移动设备上使用 TensorFlow Lite 和 Core ML](docs/intel-mobi-proj-tf/11.md)
    +   [十二、在 Raspberry Pi 上开发 TensorFlow 应用](docs/intel-mobi-proj-tf/12.md)
