

# 九、预测 GAN 的未来



如果您已完成本书各章中的所有练习，则为学习和编码**生成对抗网络**（**GAN**）进行了很长的路要走。 世界应用。 GAN 有可能在许多不同行业中造成破坏。 科学家和研究人员开发了各种可用于构建商业应用的 GAN。 在本书中，我们探索并实现了一些最著名的 GAN 架构。

因此，让我们回顾一下到目前为止所学到的东西：

*   我们从对 GAN 的简要介绍开始，学习了各种重要概念。
*   然后，我们探索了 3D-GAN，这是一种可以生成 3D 图像的 GAN。 我们训练了 3D-GAN，以生成现实世界对象的 3D 模型，例如*飞机*或*桌子*。
*   在第三章中，我们探索了用于人脸老化的条件 GAN。 我们学习了如何使用条件 GAN 将处于年龄的的人脸图像转换为同一张脸的图像。 我们还讨论了 Age-cGAN 的各种实际应用。
*   之后，我们探索了**深度卷积生成对抗网络**（**DCGANs**），该网络用于生成动漫人物的面孔。
*   在第五章中，我们探讨了**超分辨率生成对抗网络**（**SRGAN**），该网络可用于从低分辨率图像生成高分辨率图像。 之后，我们讨论了 SRGAN 如何解决一些非常有趣的现实问题。
*   然后，我们探索了 StackGAN，我们将其用于执行文本到图像的合成任务。 我们在训练 StackGAN 之前先探索了一个数据集，然后通过讨论 StackGAN 的实际应用来结束本章。

*   在第七章中，我们探索了 CycleGAN，这是一次图像到图像的翻译任务。 我们的目标是将绘画变成照片。 我们还讨论了 CycleGAN 的实际应用
*   最后，在第八章中，我们探讨了 pix2pix 网络，这是一种条件 GAN。 我们训练了 pix2pix 网络，以根据建筑标签生成立面图像。 像其他章节一样，我们通过讨论 pix2pix 网络的实际应用来结束本章。

在本章中，我们将介绍以下主题：

*   我们对 GAN 未来的预测
*   GAN 的潜在未来应用
*   可以探索 GAN 的其他区域





# 我们对 GAN 未来的预测



我认为，GAN 的未来将具有以下特点：

*   研究团体公开接受 GAN 及其应用。
*   令人印象深刻的结果-到目前为止，GAN 在使用常规方法难以执行的任务上显示出非常令人印象深刻的结果。 例如，将低分辨率图像转换为高分辨率图像以前是一项艰巨的任务，通常是使用 CNN 进行的。 GAN 架构（例如 SRGAN 或 pix2pix）显示了 GAN 在此应用中的潜力，而 StackGAN 网络已被证明对文本到图像的合成任务很有用。 如今，任何人都可以创建 SRGAN 网络并将其训练在自己的图像上。
*   深度学习技术的进步。
*   GAN 用于商业应用。
*   GAN 训练过程的成熟。





# 改善现有的深度学习方法



监督式深度学习方法需要大量数据来训练模型。 获取该数据既昂贵又费时。 有时，无法获得数据，因为它不是公开可用的，或者如果它是公开可用的，则数据集的大小可能很小。 这是 GAN 可以营救的地方。 一旦使用相当小的数据集进行了训练，便可以部署 GAN 来从同一域生成新数据。 例如，假设您正在处理图像分类任务。 您有一个数据集，但是它不足以完成您的任务。 我们可以在现有映像上训练 GAN，然后将其部署到同一域中以生成新映像。 尽管 GAN 目前存在训练不稳定性的问题，但一些研究人员表明，可以生成逼真的图像。





# GAN 商业应用的演变



未来几年，我们将看到 GAN 的更多商业应用。 GAN 的许多商业应用已经开发，并给人留下了积极的印象。 例如，移动应用 Prisma 是 GAN 最早获得广泛成功的应用之一。 我们可能会在不久的将来看到 GAN 的民主化，一旦我们这样做了，我们将开始看到 GAN 改善了我们的日常生活。





# GAN 训练过程的成熟



自 2014 年成立以来，四年后，GAN 仍然遭受训练不稳定问题的困扰。 有时，GAN 根本无法收敛，因为两个网络都偏离了它们的训练路径。 在编写本书时，我多次遭受这个问题的困扰。 研究人员为稳定 GAN 的训练做出了许多努力。 我预测，随着深度学习领域的进步，该过程将日趋成熟，并且我们很快将能够毫无问题地训练模型。





# GAN 的潜在未来应用



GAN 的未来是光明的！ 我认为在不久的将来有可能会使用 GAN：

*   从文本创建图表
*   生成网站设计
*   压缩数据
*   药物发现与开发
*   生成文字
*   生成音乐





# 从文本创建图表



设计图表是一个漫长的过程。 这需要数小时的劳动并且需要特定的技能。 在市场营销和社会促销中，信息图表的魅力十足。 它们是社交媒体营销的主要成分。 有时，由于漫长的创建过程，公司不得不采用效率较低的策略来解决。 AI 和 GAN 可以帮助设计师进行创作。





# 生成网站设计



同样，设计网站是一个手动的，创造性的过程，需要熟练的手动工作，并且需要很长时间。 GAN 可以通过提供可以用作灵感的初始设计来协助设计师，从而节省大量金钱和时间。





# 压缩数据



互联网使我们能够将大量数据传输到任何位置，但这是有代价的。 GAN 使我们能够提高图像和视频的分辨率。 我们可以将低分辨率的图像和视频传输到它们所需的位置，然后可以使用 GAN 来提高数据质量，而这需要更少的带宽。 这带来了很多可能性。





# 药物发现与开发



使用 GAN 进行药物开发可能听起来像是一个梦想，但考虑到所需的化学和生物学特性，GAN 已被用于生成分子结构。 制药公司在新药的研发上花费了数十亿美元。 用于药物开发的 GAN 可以大大降低该成本。





# 用于生成文本的 GAN



GAN 已被证明对图像生成任务很有用。 GAN 中的大部分研究目前集中在高分辨率图像生成，文本到图像合成，样式迁移，图像到图像翻译以及其他类似任务上。 目前，对于使用 GAN 生成文本的研究还不多。 这是因为 GAN 旨在生成连续的值，因此训练 GAN 以获得离散值确实具有挑战性。 将来，  预测将在文本生成任务中进行更多的研究。





# 用于生成音乐的 GAN



使用 GAN 进行音乐生成是另一个尚未得到充分探索的领域。 音乐创作的过程充满创造力，非常复杂。 GAN 具有改变音乐产业的潜力，如果发生这种情况，我们可能很快就会聆听 GAN 创建的曲目。





# 探索 GAN



您可以探索的其他 GAN 架构包括：

*   [**BigGAN**：《用于高保真自然图像合成的大规模 GAN 训练》](https://arxiv.org/pdf/1809.11096.pdf)
*   [**WaveGAN**：《使用生成的对抗网络合成音频》](https://arxiv.org/abs/1802.04208)
*   [**BEGAN**：《BEGAN：边界均衡生成对抗网络》](https://arxiv.org/abs/1703.10717)
*   [**AC-GAN**：《使用辅助分类器 GAN 的条件图像合成》](https://arxiv.org/abs/1610.09585)

*   [**AdaGAN**：《AdaGAN：增强生成模型》](https://arxiv.org/abs/1701.02386v1)
*   [**ArtGAN**：《ArtGAN：带有条件分类 GAN 的艺术品合成》](https://arxiv.org/abs/1702.03410)
*   [**BAGAN**：《BAGAN：平衡 GAN 的数据扩充》](https://arxiv.org/abs/1803.09655)
*   [**BicycleGAN**：《从多模态图像迈向图像翻译》](https://arxiv.org/abs/1711.11586)
*   [**CapsGAN**：《CapsGAN：为生成对抗网络使用动态路由》](https://arxiv.org/abs/1806.03968)
*   [**E-GAN**：《进化生成对抗网络》](https://arxiv.org/abs/1803.00657)
*   [**WGAN**：《Wasserstein GAN》](https://arxiv.org/abs/1701.07875v2)

研究人员还开发了数百种其他 GAN 架构。





# 总结



在本书中，我的目的是让您了解 GAN 及其在世界上的应用。 你的想象力是唯一的限制。 有大量可用的不同 GAN 架构，并且它们正在变得越来越成熟。 GAN 仍有很长的路要走，因为它们仍然存在诸如训练不稳定性和模式崩溃之类的问题，但是现在已经提出了各种解决方案，包括标签平滑，实例规范化和小批量区分。 我希望这本书对您实现 GAN 有所帮助。 如果您有任何疑问，请给我发送电子邮件到 [ahikailash1@gmail.com](mailto:ahikailash1@gmail.com)。


